SELECT
  *
FROM
    Production.TransactionHistory TH
  FULL OUTER JOIN
    (SELECT
       T.ReferenceOrderID
     FROM
       HumanResources.Department D
       CROSS JOIN Production.ProductSubcategory P
       CROSS JOIN Production.TransactionHistory T
       CROSS JOIN Production.Location
     WHERE
       CAST(T.TransactionDate AS DATE) NOT IN
         (SELECT DISTINCT ModifiedDate FROM HumanResources.Department) OR
       P.Name LIKE '%Teee%') O
  ON TH.ReferenceOrderID = O.ReferenceOrderID;