USE AdventureWorks2014;
GO

CREATE FUNCTION dbo.badfnCustomerProductSummary 
  (@ProductID INT)
RETURNS @SummaryTable TABLE (
	CustomerID INT
	,ProductID INT
	,Units INT
	,cost INT )
AS
BEGIN 
INSERT @SummaryTable
SELECT   CU.CustomerID, SD.ProductID, SUM(SD.OrderQty) AS Units, SUM(SD.LineTotal) AS Cost
FROM     Sales.Customer CU
         INNER JOIN Sales.SalesOrderHeader SH
           ON SH.CustomerID = CU.CustomerID
         INNER JOIN Sales.SalesOrderDetail SD
           ON SD.SalesOrderID = SH.SalesOrderID
WHERE    SD.ProductID = @ProductID
GROUP BY CU.CustomerID, SD.ProductID

RETURN

END

GO



CREATE FUNCTION dbo.goodfnCustomerProductSummary (@ProductID INT)
  RETURNS TABLE 
AS
RETURN (
SELECT CU.CustomerID
	,SD.ProductID
	,SUM(SD.OrderQty) AS Units
	,SUM(SD.LineTotal) AS Cost
	FROM Sales.Customer CU
	INNER JOIN Sales.SalesOrderHeader SH
		ON SH.CustomerID = CU.CustomerID
	INNER JOIN Sales.SalesOrderDetail SD
		ON SD.SalesOrderID = SH.SalesOrderID
	WHERE SD.ProductID = @ProductID
	GROUP BY CU.CustomerID, SD.ProductID
)


--SELECT DISTINCT SD.ProductID 
--	FROM Sales.SalesOrderDetail SD

/*

DROP FUNCTION dbo.badfnCustomerProductSummary ;
DROP FUNCTION dbo.goodfnCustomerProductSummary;

*/

USE AdventureWorks2014;

DBCC FREEPROCCACHE
SET  STATISTICS IO ON
SET  STATISTICS PROFILE OFF
SET  STATISTICS TIME ON

SELECT *
FROM   Sales.Customer CU 
  INNER JOIN badfnCustomerProductSummary(723) CPS 
  ON CPS.CustomerID = CU.CustomerID;

SELECT *
FROM   Sales.Customer CU 
  INNER JOIN goodfnCustomerProductSummary(723) CPS 
  ON CPS.CustomerID = CU.CustomerID;
				

DECLARE @ProductID INT = 723

SELECT   CU.CustomerID, SD.ProductID, SUM(SD.OrderQTY) AS Units, SUM(SD.LineTotal) AS Cost
FROM     Sales.Customer CU
         INNER JOIN Sales.SalesOrderHeader SH
           ON SH.CustomerID = CU.CustomerID
         INNER JOIN Sales.SalesOrderDetail SD
           ON SD.SalesOrderID = SH.SalesOrderID
WHERE    SD.ProductID = @ProductID
GROUP BY CU.CustomerID, SD.ProductID;	
	
--DECLARE @ProductID INT = 723
--
--DECLARE @ProductID INT = 723
--
--SELECT Cu.Personid, QQ.*
--FROM     Sales.Customer CU
--       INNER JOIN
--         (SELECT   SH.CustomerID, SD.ProductID, SUM(SD.OrderQTY) AS Units, SUM(SD.LineTotal) AS Cost
--          FROM     Sales.SalesOrderHeader SH INNER JOIN Sales.SalesOrderDetail SD ON SD.SalesOrderID = SH.SalesOrderID
--          WHERE    SD.ProductID = @ProductID
--          GROUP BY SH.CustomerID, SD.ProductID) QQ
--       ON QQ.CustomerID = CU.CustomerID


USE AdventureWorks2014
GO
DBCC FREEPROCCACHE
SET STATISTICS IO ON
SET STATISTICS PROFILE OFF
SET STATISTICS TIME ON

SELECT * 
	FROM Sales.Customer CU
	inner join badfnCustomerProductSummary(723) CPS 
		on CPS.CustomerID = CU.CustomerID
		
		
SELECT * 
	FROM Sales.Customer CU
	inner join goodfnCustomerProductSummary(723) CPS 
		on CPS.CustomerID = CU.CustomerID
				

declare @ProductID int = 723
Select CU.CustomerID
	,SD.ProductID
	,SUM(SD.OrderQTY) as Units
	,SUM(SD.LineTotal) as Cost
	from Sales.Customer CU
	INNER JOIN Sales.SalesOrderHeader SH
		on SH.CustomerID = CU.CustomerID
	INNER JOIN Sales.SalesOrderDetail SD
		on SD.SalesOrderID = SH.SalesOrderID
	Where SD.ProductID = @ProductID
	Group By Cu.CustomerID, SD.ProductID		
	
	--declare @ProductID int = 723



----declare @ProductID int = 723
--select 	Cu.Personid, QQ.*
--	from Sales.Customer CU
--	inner join  (Select SH.CustomerID
--	,SD.ProductID
--	,SUM(SD.OrderQTY) as Units
--	,SUM(SD.LineTotal) as Cost
--	from Sales.SalesOrderHeader SH
--	INNER JOIN Sales.SalesOrderDetail SD
--		on SD.SalesOrderID = SH.SalesOrderID
--	Where SD.ProductID = @ProductID
--	Group By SH.CustomerID, SD.ProductID		 ) QQ
--	on QQ.CustomerID = CU.CustomerID
	

	
		