select 
    cur.* 
from 
    sys.dm_exec_connections con
    cross apply sys.dm_exec_cursors(con.session_id) as cur
where
    cur.fetch_buffer_size = 1 
    and cur.properties LIKE 'API%'	
-- API cursor (TSQL cursors always have fetch buffer of 1);



select record 
from sys.dm_os_ring_buffers 
where ring_buffer_type = 'RING_BUFFER_OOM';

select record 
from sys.dm_os_ring_buffers 
where ring_buffer_type = 'RING_BUFFER_BUFFER_POOL';


