DECLARE userobj_cursor LOCAL FAST_FORWARD CURSOR FOR 
SELECT
     sys.schemas.name + '.' + sys.objects.name 
FROM sys.objects, sys.schemas
WHERE object_id > 100 
	AND type_desc = 'USER_TABLE'
	AND sys.objects.schema_id = sys.schemas.schema_id
ORDER BY sys.objects.name
go

OPEN userobj_cursor
go

DECLARE @name varchar(256)
FETCH userobj_cursor INTO @name
WHILE (@@FETCH_STATUS = 0) 
BEGIN
    exec sp_spaceused @objname = @name
        fetch userobj_cursor into @name	
END
CLOSE userobj_cursor

DEALLOCATE userobj_cursor

