SET NOCOUNT ON;

IF OBJECT_ID('dbo.LockTable1', 'u') is null
CREATE TABLE dbo.LockTable1
(LockTable1ID int identity(1,1) primary key clustered
,Acolumn int not null
);

IF OBJECT_ID('dbo.LockTable2', 'u') is null
CREATE TABLE dbo.LockTable2
(LockTable2ID int identity(1,1) primary key clustered
,Acolumn int not null
);

BEGIN TRANSACTION LockPart1;

      INSERT INTO LockTable1 VALUES (1);
      UPDATE LockTable1 WITH (TABLOCK) SET Acolumn = 2

      WAITFOR DELAY '00:00:20';

      INSERT INTO LockTable2 VALUES (2);
      UPDATE LockTable2 WITH (TABLOCK) SET Acolumn = 5

COMMIT TRANSACTION LockPart1;

