/* BCP out all tables by Kevin Kline, http://KevinEKline.com, Twitter at kekline */

SET NOCOUNT ON
CREATE TABLE #a (name VARCHAR(128), id INT IDENTITY)				-- Storage for list of user tables
INSERT #a (name)  SELECT name FROM sysobjects WHERE xtype = 'U'		-- Grab list of user tables
DECLARE @id INT, @cmd VARCHAR(2000)									-- Declare variables of counter and SQL command
SELECT @id = 0														-- Initialize variable
WHILE @id < (SELECT max(id) FROM #a)								-- Start loop to build BCP command per table
BEGIN
	SELECT @id = MIN(id) FROM #a WHERE id > @id
	SELECT @cmd = 'bcp ' + db_name() + '..' + name + ' out "c:\temp\' + name + '.bcp" -S' + @@servername + ' -N -T -F1 -L500'
		FROM #a WHERE id = @id
	--EXEC master..xp_cmdshell @cmd									-- Execute BCP command
	SELECT @cmd
END
DROP TABLE #a

-- Notice any problems with this code?




-- No schema / dbowner!