SELECT so.name
FROM   sys.objects AS so 
  LEFT JOIN sys.indexes AS si 
    ON si.object_id = so.object_id 
   AND si.is_unique = 1
WHERE si.index_id IS NULL 
  AND so.type_desc = 'user_table'
ORDER BY so.name;