-- Finds those queries that have not been granted memory yet and are waiting.  Especially useful
-- when seeing heavy RESOURCE_SEMAPHORE waites, which show it shows waits caused by pending memory 
-- grants for complex memory intensive queries.
SELECT *
FROM sys.dm_exec_query_memory_grants
WHERE is_next_candidate in (0,1)
ORDER BY is_next_candidate desc, queue_id, wait_order;