SELECT  wt.waiting_task_address,
        wt.session_id,
        wt.wait_duration_ms,
        wt.wait_type,
        wt.blocking_session_id,
        wt.resource_description,
        [text],
        query_plan
FROM    sys.dm_os_waiting_tasks wt
        INNER JOIN sys.dm_exec_requests er ON wt.session_id = er.session_id
        CROSS APPLY sys.dm_exec_sql_text(sql_handle)
        CROSS APPLY sys.dm_exec_query_plan(plan_handle)
WHERE   wt.session_id > 50