use w
go

SELECT * FROM sys.dm_xe_object_columns
  WHERE [object_name] = 'sql_statement_completed' and column_type = 'data'
GO


CREATE EVENT SESSION MonitorIO ON SERVER
ADD EVENT sqlserver.sql_statement_completed
  (ACTION (sqlserver.session_resource_pool_id))
ADD TARGET package0.ring_buffer;
GO
ALTER EVENT SESSION MonitorIO ON SERVER
STATE = START;
GO

--Fragtable.sql again

SELECT CAST(xest.target_data AS XML) StatementData
  FROM sys.dm_xe_session_targets xest
JOIN sys.dm_xe_sessions xes ON
  xes.address = xest.event_session_address
WHERE xest.target_name = 'ring_buffer'
  AND xes.name = 'MonitorIO';
GO

ALTER EVENT SESSION MonitorIO ON SERVER
STATE = STOP;
GO
DROP EVENT SESSION MonitorIO ON SERVER
